function [Ar,B] = rotatepca_jw(A0,A,W);
% The assumption is that W has ones on some positions and zeros elsewhere.
% On the ones position AB will be made equal to A0

[I,R] = size(A);
B = zeros(R);
for r = 1:R
    [J] = find(W(:,r));
    AJ = A(J,:);
    if any(A0(J,r))
        B(:,r) = pinv(AJ'*AJ)*AJ'*A0(J,r);
    else
        Y = A0(J,r) - AJ(:,r);
        AJR = AJ(:,[1:r-1 r+1:R]);
        B([1:r-1 r+1:R],r) = pinv(AJR'*AJR)*AJR'*Y;
        B(r,r) = 1;
    end
end
Ar = A*B;
ssq(W.*(Ar - A0))
